version: '3.9'

x-node-base: &node-base
  image: registry.gitlab.com/pandacoin/bluewallet/groundcontrol:latest
  build: .
  logging:
    driver: "json-file"
    options:
      max-file: 5
      max-size: 10m
  environment:
    - JAWSDB_MARIA_URL=mysql://root:root@mariadb/groundcontrol
    - FCM_SERVER_KEY=MY_FCM_SERVER_KEY
    - APNS_PEM=MY_APNS_PEM
    - BITCOIN_RPC=http://rpc:rpc@pandacoind:22444
    - APNS_TOPIC=de.amdoge.bluewallet
  restart: always
  networks:
    - default
    - pandacoind

services:
  mariadb:
    image: mariadb
    environment:
      - MYSQL_ROOT_PASSWORD=root
      - MYSQL_DATABASE=groundcontrol
    volumes:
      - mariadb-data:/var/lib/mysql
  node:
    <<: *node-base
    deploy:
      labels:
        - traefik.enable=true
        - traefik.docker.network=traefik-public
        - traefik.constraint-label=traefik-public
        - traefik.http.routers.groundcontrol-bluewallet-http.rule=Host(`groundcontrol-bluewallet.thepandacoin.net`)
        - traefik.http.routers.groundcontrol-bluewallet-http.entrypoints=http
        - traefik.http.routers.groundcontrol-bluewallet-http.middlewares=https-redirect
        - traefik.http.routers.groundcontrol-bluewallet-https.rule=Host(`groundcontrol-bluewallet.thepandacoin.net`)
        - traefik.http.routers.groundcontrol-bluewallet-https.entrypoints=https
        - traefik.http.routers.groundcontrol-bluewallet-https.tls=true
        - traefik.http.routers.groundcontrol-bluewallet-https.tls.certresolver=le
        - traefik.http.services.groundcontrol-bluewallet.loadbalancer.server.port=3001
    command: npm run start
    networks:
      - default
      - pandacoind
      - traefik-public
  node-worker-processmempool:
    <<: *node-base
    command: npm run worker-processmempool
  node-worker-blockprocessor:
    <<: *node-base
    command: npm run worker-blockprocessor
  node-worker-sender:
    <<: *node-base
    command: npm run worker-sender

volumes:
  mariadb-data:

networks:
  pandacoind:
    external: true
    name: pandacoind_pandacoind
  traefik-public:
    external: true
